diff --git a/gas/testsuite/gas/arc/adc.d b/gas/testsuite/gas/arc/adc.d
index ccb7b7cbdec..ed55430d444 100644
--- a/gas/testsuite/gas/arc/adc.d
+++ b/gas/testsuite/gas/arc/adc.d
@@ -6,7 +6,7 @@
 Disassembly of section .text:
 0x[0-9a-f]+ 2101 0080           	adc	r0,r1,r2
 0x[0-9a-f]+ 2301 371a           	adc	gp,fp,sp
-0x[0-9a-f]+ 2601 37dd           	adc	ilink,r30,blink
+0x[0-9a-f]+ 2601 37dd           	adc	ilink1,ilink2,blink
 0x[0-9a-f]+ 2141 0000           	adc	r0,r1,0
 0x[0-9a-f]+ 2601 7080 0000 0000 	adc	r0,0,r2
 0x[0-9a-f]+ 2101 00be           	adc	0,r1,r2
@@ -30,8 +30,8 @@ Disassembly of section .text:
 0x[0-9a-f]+ 22c1 2503           	adc.p	r18,r18,r20
 0x[0-9a-f]+ 25c1 25c3           	adc.p	r21,r21,r23
 0x[0-9a-f]+ 20c1 3684           	adc.n	r24,r24,gp
-0x[0-9a-f]+ 23c1 3744           	adc.n	fp,fp,ilink
-0x[0-9a-f]+ 26c1 37c5           	adc.c	r30,r30,blink
+0x[0-9a-f]+ 23c1 3744           	adc.n	fp,fp,ilink1
+0x[0-9a-f]+ 26c1 37c5           	adc.c	ilink2,ilink2,blink
 0x[0-9a-f]+ 23c1 00c5           	adc.c	r3,r3,r3
 0x[0-9a-f]+ 23c1 0205           	adc.c	r3,r3,r8
 0x[0-9a-f]+ 23c1 0106           	adc.nc	r3,r3,r4
diff --git a/gas/testsuite/gas/arc/add.d b/gas/testsuite/gas/arc/add.d
index f7bae70f8cd..02571366a72 100644
--- a/gas/testsuite/gas/arc/add.d
+++ b/gas/testsuite/gas/arc/add.d
@@ -6,7 +6,7 @@
 Disassembly of section .text:
 0x[0-9a-f]+ 2100 0080           	add	r0,r1,r2
 0x[0-9a-f]+ 2300 371a           	add	gp,fp,sp
-0x[0-9a-f]+ 2600 37dd           	add	ilink,r30,blink
+0x[0-9a-f]+ 2600 37dd           	add	ilink1,ilink2,blink
 0x[0-9a-f]+ 2140 0000           	add	r0,r1,0
 0x[0-9a-f]+ 2600 7080 0000 0000 	add	r0,0,r2
 0x[0-9a-f]+ 2100 00be           	add	0,r1,r2
@@ -30,8 +30,8 @@ Disassembly of section .text:
 0x[0-9a-f]+ 22c0 2503           	add.p	r18,r18,r20
 0x[0-9a-f]+ 25c0 25c3           	add.p	r21,r21,r23
 0x[0-9a-f]+ 20c0 3684           	add.n	r24,r24,gp
-0x[0-9a-f]+ 23c0 3744           	add.n	fp,fp,ilink
-0x[0-9a-f]+ 26c0 37c5           	add.c	r30,r30,blink
+0x[0-9a-f]+ 23c0 3744           	add.n	fp,fp,ilink1
+0x[0-9a-f]+ 26c0 37c5           	add.c	ilink2,ilink2,blink
 0x[0-9a-f]+ 23c0 00c5           	add.c	r3,r3,r3
 0x[0-9a-f]+ 23c0 0205           	add.c	r3,r3,r8
 0x[0-9a-f]+ 23c0 0106           	add.nc	r3,r3,r4
diff --git a/gas/testsuite/gas/arc/and.d b/gas/testsuite/gas/arc/and.d
index 99e30f5a47e..3dc3302e941 100644
--- a/gas/testsuite/gas/arc/and.d
+++ b/gas/testsuite/gas/arc/and.d
@@ -6,7 +6,7 @@
 Disassembly of section .text:
 0x[0-9a-f]+ 2104 0080           	and	r0,r1,r2
 0x[0-9a-f]+ 2304 371a           	and	gp,fp,sp
-0x[0-9a-f]+ 2604 37dd           	and	ilink,r30,blink
+0x[0-9a-f]+ 2604 37dd           	and	ilink1,ilink2,blink
 0x[0-9a-f]+ 2144 0000           	and	r0,r1,0
 0x[0-9a-f]+ 2604 7080 0000 0000 	and	r0,0,r2
 0x[0-9a-f]+ 2104 00be           	and	0,r1,r2
@@ -30,8 +30,8 @@ Disassembly of section .text:
 0x[0-9a-f]+ 22c4 2503           	and.p	r18,r18,r20
 0x[0-9a-f]+ 25c4 25c3           	and.p	r21,r21,r23
 0x[0-9a-f]+ 20c4 3684           	and.n	r24,r24,gp
-0x[0-9a-f]+ 23c4 3744           	and.n	fp,fp,ilink
-0x[0-9a-f]+ 26c4 37c5           	and.c	r30,r30,blink
+0x[0-9a-f]+ 23c4 3744           	and.n	fp,fp,ilink1
+0x[0-9a-f]+ 26c4 37c5           	and.c	ilink2,ilink2,blink
 0x[0-9a-f]+ 23c4 00c5           	and.c	r3,r3,r3
 0x[0-9a-f]+ 23c4 0205           	and.c	r3,r3,r8
 0x[0-9a-f]+ 23c4 0106           	and.nc	r3,r3,r4
diff --git a/gas/testsuite/gas/arc/arc.exp b/gas/testsuite/gas/arc/arc.exp
index 851db0c5854..a30aee2d486 100644
--- a/gas/testsuite/gas/arc/arc.exp
+++ b/gas/testsuite/gas/arc/arc.exp
@@ -17,6 +17,6 @@
 # ARC base instruction set
 
 # ARC library extensions
-if [istarget arc*-*-*] then {
+if [istarget arc-*-*] then {
      run_dump_tests [lsort [glob -nocomplain $srcdir/$subdir/*.d]]
 }
diff --git a/gas/testsuite/gas/arc/asl.d b/gas/testsuite/gas/arc/asl.d
index f316378d899..6734c787491 100644
--- a/gas/testsuite/gas/arc/asl.d
+++ b/gas/testsuite/gas/arc/asl.d
@@ -6,7 +6,7 @@
 Disassembly of section .text:
 0x[0-9a-f]+ 2900 0080           	asl	r0,r1,r2
 0x[0-9a-f]+ 2b00 371a           	asl	gp,fp,sp
-0x[0-9a-f]+ 2e00 37dd           	asl	ilink,r30,blink
+0x[0-9a-f]+ 2e00 37dd           	asl	ilink1,ilink2,blink
 0x[0-9a-f]+ 2940 0000           	asl	r0,r1,0
 0x[0-9a-f]+ 2e00 7080 0000 0000 	asl	r0,0,r2
 0x[0-9a-f]+ 2900 00be           	asl	0,r1,r2
@@ -30,8 +30,8 @@ Disassembly of section .text:
 0x[0-9a-f]+ 2ac0 2503           	asl.p	r18,r18,r20
 0x[0-9a-f]+ 2dc0 25c3           	asl.p	r21,r21,r23
 0x[0-9a-f]+ 28c0 3684           	asl.n	r24,r24,gp
-0x[0-9a-f]+ 2bc0 3744           	asl.n	fp,fp,ilink
-0x[0-9a-f]+ 2ec0 37c5           	asl.c	r30,r30,blink
+0x[0-9a-f]+ 2bc0 3744           	asl.n	fp,fp,ilink1
+0x[0-9a-f]+ 2ec0 37c5           	asl.c	ilink2,ilink2,blink
 0x[0-9a-f]+ 2bc0 00c5           	asl.c	r3,r3,r3
 0x[0-9a-f]+ 2bc0 0205           	asl.c	r3,r3,r8
 0x[0-9a-f]+ 2bc0 0106           	asl.nc	r3,r3,r4
diff --git a/gas/testsuite/gas/arc/asr.d b/gas/testsuite/gas/arc/asr.d
index d72878ba2d5..a52478f8bc7 100644
--- a/gas/testsuite/gas/arc/asr.d
+++ b/gas/testsuite/gas/arc/asr.d
@@ -6,7 +6,7 @@
 Disassembly of section .text:
 0x[0-9a-f]+ 2902 0080           	asr	r0,r1,r2
 0x[0-9a-f]+ 2b02 371a           	asr	gp,fp,sp
-0x[0-9a-f]+ 2e02 37dd           	asr	ilink,r30,blink
+0x[0-9a-f]+ 2e02 37dd           	asr	ilink1,ilink2,blink
 0x[0-9a-f]+ 2942 0000           	asr	r0,r1,0
 0x[0-9a-f]+ 2e02 7080 0000 0000 	asr	r0,0,r2
 0x[0-9a-f]+ 2902 00be           	asr	0,r1,r2
@@ -30,8 +30,8 @@ Disassembly of section .text:
 0x[0-9a-f]+ 2ac2 2503           	asr.p	r18,r18,r20
 0x[0-9a-f]+ 2dc2 25c3           	asr.p	r21,r21,r23
 0x[0-9a-f]+ 28c2 3684           	asr.n	r24,r24,gp
-0x[0-9a-f]+ 2bc2 3744           	asr.n	fp,fp,ilink
-0x[0-9a-f]+ 2ec2 37c5           	asr.c	r30,r30,blink
+0x[0-9a-f]+ 2bc2 3744           	asr.n	fp,fp,ilink1
+0x[0-9a-f]+ 2ec2 37c5           	asr.c	ilink2,ilink2,blink
 0x[0-9a-f]+ 2bc2 00c5           	asr.c	r3,r3,r3
 0x[0-9a-f]+ 2bc2 0205           	asr.c	r3,r3,r8
 0x[0-9a-f]+ 2bc2 0106           	asr.nc	r3,r3,r4
diff --git a/gas/testsuite/gas/arc/bic.d b/gas/testsuite/gas/arc/bic.d
index 57124cd7e63..8bcd504da94 100644
--- a/gas/testsuite/gas/arc/bic.d
+++ b/gas/testsuite/gas/arc/bic.d
@@ -6,7 +6,7 @@
 Disassembly of section .text:
 0x[0-9a-f]+ 2106 0080           	bic	r0,r1,r2
 0x[0-9a-f]+ 2306 371a           	bic	gp,fp,sp
-0x[0-9a-f]+ 2606 37dd           	bic	ilink,r30,blink
+0x[0-9a-f]+ 2606 37dd           	bic	ilink1,ilink2,blink
 0x[0-9a-f]+ 2146 0000           	bic	r0,r1,0
 0x[0-9a-f]+ 2606 7080 0000 0000 	bic	r0,0,r2
 0x[0-9a-f]+ 2106 00be           	bic	0,r1,r2
@@ -30,8 +30,8 @@ Disassembly of section .text:
 0x[0-9a-f]+ 22c6 2503           	bic.p	r18,r18,r20
 0x[0-9a-f]+ 25c6 25c3           	bic.p	r21,r21,r23
 0x[0-9a-f]+ 20c6 3684           	bic.n	r24,r24,gp
-0x[0-9a-f]+ 23c6 3744           	bic.n	fp,fp,ilink
-0x[0-9a-f]+ 26c6 37c5           	bic.c	r30,r30,blink
+0x[0-9a-f]+ 23c6 3744           	bic.n	fp,fp,ilink1
+0x[0-9a-f]+ 26c6 37c5           	bic.c	ilink2,ilink2,blink
 0x[0-9a-f]+ 23c6 00c5           	bic.c	r3,r3,r3
 0x[0-9a-f]+ 23c6 0205           	bic.c	r3,r3,r8
 0x[0-9a-f]+ 23c6 0106           	bic.nc	r3,r3,r4
diff --git a/gas/testsuite/gas/arc/leave_enter.d b/gas/testsuite/gas/arc/leave_enter.d
index 821656af3de..7e7a0546d10 100644
--- a/gas/testsuite/gas/arc/leave_enter.d
+++ b/gas/testsuite/gas/arc/leave_enter.d
@@ -6,13 +6,13 @@
 Disassembly of section .text:
 0x[0-9a-f]+\s+c0c2\s+leave_s	\[r13\]
 0x[0-9a-f]+\s+c0c2\s+leave_s	\[r13\]
-0x[0-9a-f]+\s+c4dc\s+leave_s	\[r13-gp,pcl\]
-0x[0-9a-f]+\s+c1dc\s+leave_s	\[r13-gp,fp\]
-0x[0-9a-f]+\s+c2dc\s+leave_s	\[r13-gp,blink\]
-0x[0-9a-f]+\s+c3dc\s+leave_s	\[r13-gp,fp,blink\]
-0x[0-9a-f]+\s+c5dc\s+leave_s	\[r13-gp,fp,pcl\]
-0x[0-9a-f]+\s+c6dc\s+leave_s	\[r13-gp,blink,pcl\]
-0x[0-9a-f]+\s+c7dc\s+leave_s	\[r13-gp,fp,blink,pcl\]
+0x[0-9a-f]+\s+c4dc\s+leave_s	\[r13-r26,pcl\]
+0x[0-9a-f]+\s+c1dc\s+leave_s	\[r13-r26,fp\]
+0x[0-9a-f]+\s+c2dc\s+leave_s	\[r13-r26,blink\]
+0x[0-9a-f]+\s+c3dc\s+leave_s	\[r13-r26,fp,blink\]
+0x[0-9a-f]+\s+c5dc\s+leave_s	\[r13-r26,fp,pcl\]
+0x[0-9a-f]+\s+c6dc\s+leave_s	\[r13-r26,blink,pcl\]
+0x[0-9a-f]+\s+c7dc\s+leave_s	\[r13-r26,fp,blink,pcl\]
 0x[0-9a-f]+\s+c6c2\s+leave_s	\[r13,blink,pcl\]
 0x[0-9a-f]+\s+c6c0\s+leave_s	\[blink,pcl\]
 0x[0-9a-f]+\s+c1c0\s+leave_s	\[fp\]
@@ -21,9 +21,9 @@ Disassembly of section .text:
 0x[0-9a-f]+\s+1100 0000\s+ld	r0,\[r1\]
 0x[0-9a-f]+\s+c0e2\s+enter_s	\[r13\]
 0x[0-9a-f]+\s+c0e2\s+enter_s	\[r13\]
-0x[0-9a-f]+\s+c1fc\s+enter_s	\[r13-gp,fp\]
-0x[0-9a-f]+\s+c2fc\s+enter_s	\[r13-gp,blink\]
-0x[0-9a-f]+\s+c3fc\s+enter_s	\[r13-gp,fp,blink\]
+0x[0-9a-f]+\s+c1fc\s+enter_s	\[r13-r26,fp\]
+0x[0-9a-f]+\s+c2fc\s+enter_s	\[r13-r26,blink\]
+0x[0-9a-f]+\s+c3fc\s+enter_s	\[r13-r26,fp,blink\]
 0x[0-9a-f]+\s+c2e2\s+enter_s	\[r13,blink]
 0x[0-9a-f]+\s+c2e0\s+enter_s	\[blink\]
 0x[0-9a-f]+\s+c3e0\s+enter_s	\[fp,blink\]
diff --git a/gas/testsuite/gas/arc/lsr.d b/gas/testsuite/gas/arc/lsr.d
index 8ce4d1c57e0..cc019b7fa6e 100644
--- a/gas/testsuite/gas/arc/lsr.d
+++ b/gas/testsuite/gas/arc/lsr.d
@@ -6,7 +6,7 @@
 Disassembly of section .text:
 0x[0-9a-f]+ 2901 0080           	lsr	r0,r1,r2
 0x[0-9a-f]+ 2b01 371a           	lsr	gp,fp,sp
-0x[0-9a-f]+ 2e01 37dd           	lsr	ilink,r30,blink
+0x[0-9a-f]+ 2e01 37dd           	lsr	ilink1,ilink2,blink
 0x[0-9a-f]+ 2941 0000           	lsr	r0,r1,0
 0x[0-9a-f]+ 2e01 7080 0000 0000 	lsr	r0,0,r2
 0x[0-9a-f]+ 2901 00be           	lsr	0,r1,r2
@@ -30,8 +30,8 @@ Disassembly of section .text:
 0x[0-9a-f]+ 2ac1 2503           	lsr.p	r18,r18,r20
 0x[0-9a-f]+ 2dc1 25c3           	lsr.p	r21,r21,r23
 0x[0-9a-f]+ 28c1 3684           	lsr.n	r24,r24,gp
-0x[0-9a-f]+ 2bc1 3744           	lsr.n	fp,fp,ilink
-0x[0-9a-f]+ 2ec1 37c5           	lsr.c	r30,r30,blink
+0x[0-9a-f]+ 2bc1 3744           	lsr.n	fp,fp,ilink1
+0x[0-9a-f]+ 2ec1 37c5           	lsr.c	ilink2,ilink2,blink
 0x[0-9a-f]+ 2bc1 00c5           	lsr.c	r3,r3,r3
 0x[0-9a-f]+ 2bc1 0205           	lsr.c	r3,r3,r8
 0x[0-9a-f]+ 2bc1 0106           	lsr.nc	r3,r3,r4
diff --git a/gas/testsuite/gas/arc/nps400-1.d b/gas/testsuite/gas/arc/nps400-1.d
index 707b982f81a..dc373a5d177 100644
--- a/gas/testsuite/gas/arc/nps400-1.d
+++ b/gas/testsuite/gas/arc/nps400-1.d
@@ -18,7 +18,7 @@ Disassembly of section .text:
   24:	4878 ffff           	movh\.cl	r3,0xffff
   28:	49cf 0906           	movbi	r14,r14,0x6,0x8,0x4
   2c:	4aff 0174           	movbi\.f	r23,r23,0x14,0xb,0x1
-  30:	4bcf 864a           	movbi\.cl	r30,0xa,0x12,0x2
+  30:	4bcf 864a           	movbi\.cl	ilink2,0xa,0x12,0x2
   34:	48df 8c09           	movbi\.f\.cl	r6,0x9,0,0x8
   38:	4843 a845           	decode1	r0,r0,r2,0x5,0xb
   3c:	4853 a845           	decode1\.f	r0,r0,r2,0x5,0xb
diff --git a/gas/testsuite/gas/arc/or.d b/gas/testsuite/gas/arc/or.d
index 693421bd506..5b766895de2 100644
--- a/gas/testsuite/gas/arc/or.d
+++ b/gas/testsuite/gas/arc/or.d
@@ -6,7 +6,7 @@
 Disassembly of section .text:
 0x[0-9a-f]+ 2105 0080           	or	r0,r1,r2
 0x[0-9a-f]+ 2305 371a           	or	gp,fp,sp
-0x[0-9a-f]+ 2605 37dd           	or	ilink,r30,blink
+0x[0-9a-f]+ 2605 37dd           	or	ilink1,ilink2,blink
 0x[0-9a-f]+ 2145 0000           	or	r0,r1,0
 0x[0-9a-f]+ 2605 7080 0000 0000 	or	r0,0,r2
 0x[0-9a-f]+ 2105 00be           	or	0,r1,r2
@@ -30,8 +30,8 @@ Disassembly of section .text:
 0x[0-9a-f]+ 22c5 2503           	or.p	r18,r18,r20
 0x[0-9a-f]+ 25c5 25c3           	or.p	r21,r21,r23
 0x[0-9a-f]+ 20c5 3684           	or.n	r24,r24,gp
-0x[0-9a-f]+ 23c5 3744           	or.n	fp,fp,ilink
-0x[0-9a-f]+ 26c5 37c5           	or.c	r30,r30,blink
+0x[0-9a-f]+ 23c5 3744           	or.n	fp,fp,ilink1
+0x[0-9a-f]+ 26c5 37c5           	or.c	ilink2,ilink2,blink
 0x[0-9a-f]+ 23c5 00c5           	or.c	r3,r3,r3
 0x[0-9a-f]+ 23c5 0205           	or.c	r3,r3,r8
 0x[0-9a-f]+ 23c5 0106           	or.nc	r3,r3,r4
diff --git a/gas/testsuite/gas/arc/ror.d b/gas/testsuite/gas/arc/ror.d
index 0e25c4c4dd3..abb3783f4c0 100644
--- a/gas/testsuite/gas/arc/ror.d
+++ b/gas/testsuite/gas/arc/ror.d
@@ -6,7 +6,7 @@
 Disassembly of section .text:
 0x[0-9a-f]+ 2903 0080           	ror	r0,r1,r2
 0x[0-9a-f]+ 2b03 371a           	ror	gp,fp,sp
-0x[0-9a-f]+ 2e03 37dd           	ror	ilink,r30,blink
+0x[0-9a-f]+ 2e03 37dd           	ror	ilink1,ilink2,blink
 0x[0-9a-f]+ 2943 0000           	ror	r0,r1,0
 0x[0-9a-f]+ 2e03 7080 0000 0000 	ror	r0,0,r2
 0x[0-9a-f]+ 2903 00be           	ror	0,r1,r2
@@ -30,8 +30,8 @@ Disassembly of section .text:
 0x[0-9a-f]+ 2ac3 2503           	ror.p	r18,r18,r20
 0x[0-9a-f]+ 2dc3 25c3           	ror.p	r21,r21,r23
 0x[0-9a-f]+ 28c3 3684           	ror.n	r24,r24,gp
-0x[0-9a-f]+ 2bc3 3744           	ror.n	fp,fp,ilink
-0x[0-9a-f]+ 2ec3 37c5           	ror.c	r30,r30,blink
+0x[0-9a-f]+ 2bc3 3744           	ror.n	fp,fp,ilink1
+0x[0-9a-f]+ 2ec3 37c5           	ror.c	ilink2,ilink2,blink
 0x[0-9a-f]+ 2bc3 00c5           	ror.c	r3,r3,r3
 0x[0-9a-f]+ 2bc3 0205           	ror.c	r3,r3,r8
 0x[0-9a-f]+ 2bc3 0106           	ror.nc	r3,r3,r4
diff --git a/gas/testsuite/gas/arc/sbc.d b/gas/testsuite/gas/arc/sbc.d
index bca7deec610..2acc0e3a5d4 100644
--- a/gas/testsuite/gas/arc/sbc.d
+++ b/gas/testsuite/gas/arc/sbc.d
@@ -6,7 +6,7 @@
 Disassembly of section .text:
 0x[0-9a-f]+ 2103 0080           	sbc	r0,r1,r2
 0x[0-9a-f]+ 2303 371a           	sbc	gp,fp,sp
-0x[0-9a-f]+ 2603 37dd           	sbc	ilink,r30,blink
+0x[0-9a-f]+ 2603 37dd           	sbc	ilink1,ilink2,blink
 0x[0-9a-f]+ 2143 0000           	sbc	r0,r1,0
 0x[0-9a-f]+ 2603 7080 0000 0000 	sbc	r0,0,r2
 0x[0-9a-f]+ 2103 00be           	sbc	0,r1,r2
@@ -30,8 +30,8 @@ Disassembly of section .text:
 0x[0-9a-f]+ 22c3 2503           	sbc.p	r18,r18,r20
 0x[0-9a-f]+ 25c3 25c3           	sbc.p	r21,r21,r23
 0x[0-9a-f]+ 20c3 3684           	sbc.n	r24,r24,gp
-0x[0-9a-f]+ 23c3 3744           	sbc.n	fp,fp,ilink
-0x[0-9a-f]+ 26c3 37c5           	sbc.c	r30,r30,blink
+0x[0-9a-f]+ 23c3 3744           	sbc.n	fp,fp,ilink1
+0x[0-9a-f]+ 26c3 37c5           	sbc.c	ilink2,ilink2,blink
 0x[0-9a-f]+ 23c3 00c5           	sbc.c	r3,r3,r3
 0x[0-9a-f]+ 23c3 0205           	sbc.c	r3,r3,r8
 0x[0-9a-f]+ 23c3 0106           	sbc.nc	r3,r3,r4
diff --git a/gas/testsuite/gas/arc/sub.d b/gas/testsuite/gas/arc/sub.d
index 520be7c7417..75c5432eba6 100644
--- a/gas/testsuite/gas/arc/sub.d
+++ b/gas/testsuite/gas/arc/sub.d
@@ -6,7 +6,7 @@
 Disassembly of section .text:
 0x[0-9a-f]+ 2102 0080           	sub	r0,r1,r2
 0x[0-9a-f]+ 2302 371a           	sub	gp,fp,sp
-0x[0-9a-f]+ 2602 37dd           	sub	ilink,r30,blink
+0x[0-9a-f]+ 2602 37dd           	sub	ilink1,ilink2,blink
 0x[0-9a-f]+ 2142 0000           	sub	r0,r1,0
 0x[0-9a-f]+ 2602 7080 0000 0000 	sub	r0,0,r2
 0x[0-9a-f]+ 2102 00be           	sub	0,r1,r2
@@ -30,8 +30,8 @@ Disassembly of section .text:
 0x[0-9a-f]+ 22c2 2503           	sub.p	r18,r18,r20
 0x[0-9a-f]+ 25c2 25c3           	sub.p	r21,r21,r23
 0x[0-9a-f]+ 20c2 3684           	sub.n	r24,r24,gp
-0x[0-9a-f]+ 23c2 3744           	sub.n	fp,fp,ilink
-0x[0-9a-f]+ 26c2 37c5           	sub.c	r30,r30,blink
+0x[0-9a-f]+ 23c2 3744           	sub.n	fp,fp,ilink1
+0x[0-9a-f]+ 26c2 37c5           	sub.c	ilink2,ilink2,blink
 0x[0-9a-f]+ 23c2 00c5           	sub.c	r3,r3,r3
 0x[0-9a-f]+ 23c2 0205           	sub.c	r3,r3,r8
 0x[0-9a-f]+ 23c2 0106           	sub.nc	r3,r3,r4
diff --git a/gas/testsuite/gas/arc/textinsn3op.d b/gas/testsuite/gas/arc/textinsn3op.d
index 2615885a8ee..09f86b240a2 100644
--- a/gas/testsuite/gas/arc/textinsn3op.d
+++ b/gas/testsuite/gas/arc/textinsn3op.d
@@ -1,3 +1,4 @@
+#as: -mcpu=arc700
 #objdump: -dr
 
 .*: +file format .*arc.*
@@ -8,7 +9,7 @@ Disassembly of section .text:
 [0-9a-f]+ <.text>:
    0:	3930 0080           	myinsn	r0,r1,r2
    4:	3b30 371a           	myinsn	gp,fp,sp
-   8:	3e30 37dd           	myinsn	ilink,r30,blink
+   8:	3e30 37dd           	myinsn	ilink1,ilink2,blink
    c:	3970 0000           	myinsn	r0,r1,0
   10:	3e30 7080 0000 0000 	myinsn	r0,0,r2
   18:	3930 00be           	myinsn	0,r1,r2
@@ -32,8 +33,8 @@ Disassembly of section .text:
   84:	3af0 2503           	myinsn.p	r18,r18,r20
   88:	3df0 25c3           	myinsn.p	r21,r21,r23
   8c:	38f0 3684           	myinsn.n	r24,r24,gp
-  90:	3bf0 3744           	myinsn.n	fp,fp,ilink
-  94:	3ef0 37c5           	myinsn.c	r30,r30,blink
+  90:	3bf0 3744           	myinsn.n	fp,fp,ilink1
+  94:	3ef0 37c5           	myinsn.c	ilink2,ilink2,blink
   98:	3bf0 00c5           	myinsn.c	r3,r3,r3
   9c:	3bf0 0205           	myinsn.c	r3,r3,r8
   a0:	3bf0 0106           	myinsn.nc	r3,r3,r4
diff --git a/gas/testsuite/gas/arc/warn.exp b/gas/testsuite/gas/arc/warn.exp
index b3551f31710..b584d6bd298 100644
--- a/gas/testsuite/gas/arc/warn.exp
+++ b/gas/testsuite/gas/arc/warn.exp
@@ -15,8 +15,7 @@
 # Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA 02110-1301, USA.  
 
 # Test assembler warnings.
-
-if [istarget arc*-*-*] {
+if [istarget arc-*-*] {
     load_lib gas-dg.exp
     dg-init
     dg-runtest [lsort [glob -nocomplain $srcdir/$subdir/*warn*.s $srcdir/$subdir/*err.s]] "" ""
diff --git a/gas/testsuite/gas/arc/xor.d b/gas/testsuite/gas/arc/xor.d
index b4b7e08ec73..d4947d8607f 100644
--- a/gas/testsuite/gas/arc/xor.d
+++ b/gas/testsuite/gas/arc/xor.d
@@ -6,7 +6,7 @@
 Disassembly of section .text:
 0x[0-9a-f]+ 2107 0080           	xor	r0,r1,r2
 0x[0-9a-f]+ 2307 371a           	xor	gp,fp,sp
-0x[0-9a-f]+ 2607 37dd           	xor	ilink,r30,blink
+0x[0-9a-f]+ 2607 37dd           	xor	ilink1,ilink2,blink
 0x[0-9a-f]+ 2147 0000           	xor	r0,r1,0
 0x[0-9a-f]+ 2607 7080 0000 0000 	xor	r0,0,r2
 0x[0-9a-f]+ 2107 00be           	xor	0,r1,r2
@@ -30,8 +30,8 @@ Disassembly of section .text:
 0x[0-9a-f]+ 22c7 2503           	xor.p	r18,r18,r20
 0x[0-9a-f]+ 25c7 25c3           	xor.p	r21,r21,r23
 0x[0-9a-f]+ 20c7 3684           	xor.n	r24,r24,gp
-0x[0-9a-f]+ 23c7 3744           	xor.n	fp,fp,ilink
-0x[0-9a-f]+ 26c7 37c5           	xor.c	r30,r30,blink
+0x[0-9a-f]+ 23c7 3744           	xor.n	fp,fp,ilink1
+0x[0-9a-f]+ 26c7 37c5           	xor.c	ilink2,ilink2,blink
 0x[0-9a-f]+ 23c7 00c5           	xor.c	r3,r3,r3
 0x[0-9a-f]+ 23c7 0205           	xor.c	r3,r3,r8
 0x[0-9a-f]+ 23c7 0106           	xor.nc	r3,r3,r4